import sys, os

scale = 0.7
radius = 5
rstroke = 1
textoffset = 5
fontsize=10

stdconcolor = "green"
stdrailcolor = "blue"

def getCircle(x,y,r,c):
    return "<circle cx=\"{0}\" cy=\"{1}\" r=\"{2}\" stroke=\"black\" stroke-width=\"{3}\" fill=\"{4}\" />\n".format(x,y,r,rstroke,c)

def getLine(x1,y1,x2,y2,scale,c):
    xh = x1 + (x2 -x1) * 0.5
    yh = y1 + (y2 -y1) *0.5

    return "<polyline points=\"{0},{1} {2},{3} {4},{5}\" style=\"fill:none;stroke:{6};stroke-width:3\" />\n".format(x1*scale,y1*scale,xh*scale,yh*scale,x2*scale,y2*scale,c)
    
def getText(x,y,text):
    return "<text x=\"{0}\" y=\"{1}\" fill=\"black\" style=\"font-size:{3}px\">{2}</text>\n".format(x,y,text,fontsize)
    
    
f = open("coords.csv","rb")

l = []

lcount = 1

minx = 1000
maxx = -1000
miny = 1000
maxy = -1000

for line in f:
    try:
        name,x,y,abgang = line.split(",")
        x = int(x)
        y = int(y)
        abgang = int(abgang)
        print [name,x,y,lcount]
        l.append([name,x,y,lcount,abgang])
        maxx = max(x,maxx)
        maxy = max(y,maxy)
        minx = min(x,minx)
        miny = min(y,miny)
            
        lcount += 1
    except:
        pass
f.close()

coordDict = {}

for item in l:
    coordDict[item[3]] = [item[1],item[2]]

f = open("connections.csv","rb")

con = []
railcon = []
for line in f:
    temp = [ x for x in line.split(",")]

    tempcon = [ int(i[1:]) for i in temp[1:] if i[0] == "A"]
    
    temprail = [int(i[1:]) for i in temp[1:] if i[0] == "B"]
    if len(tempcon) > 0:
        con.append([int(temp[0])] + tempcon)
    if len(temprail) > 0:
        railcon.append([int(temp[0])] + temprail)

    


o = open("output.svg","wb")
# o.write("<!DOCTYPE html>\n")
# o.write("<html>\n")
# o.write("<body>\n")

o.write("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n")
o.write("<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20001102//EN\" \"http://www.w3.org/TR/2000/CR-SVG-20001102/DTD/svg-20001102.dtd\">\n")

o.write("<svg viewBox=\"{0} {1} {2} {3}\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" width=\"100%\" height=\"100%\">\n".format(minx*scale-radius,miny*scale-radius,(maxx-minx)*scale+2*radius,(maxy-miny)*scale+2*radius))
for item in railcon:
    tempcoords = [ coordDict[x] for x in item]
    start = tempcoords[0]
    ends = tempcoords[1:]
    for end in ends:
        o.write(getLine(start[0],start[1],end[0],end[1],scale,stdrailcolor)) 
for item in con:
    tempcoords = [ coordDict[x] for x in item]
    start = tempcoords[0]
    ends = tempcoords[1:]
    for end in ends:
        o.write(getLine(start[0],start[1],end[0],end[1],scale,stdconcolor))   
for item in l:
    name = item[0]
    x = item[1]
    y = item[2]
    abgang = item[4]
    x=x*scale
    y=y*scale
    o.write( getText(x+textoffset,y+textoffset,name))
    o.write(  getCircle(x,y,radius,"red"))
    if abgang == 1:
        o.write(  getCircle(x,y,radius*0.5,"blue"))

    
o.write("</svg>\n") 
o.close()

# os.startfile("output.svg")